PrefixLines (Apache Ant API)
Description: declaration: package: org.apache.tools.ant.filters, class: PrefixLines

# Class PrefixLines

java.lang.Object
java.io.Reader
java.io.FilterReader
org.apache.tools.ant.filters.BaseFilterReader
org.apache.tools.ant.filters.BaseParamFilterReader
org.apache.tools.ant.filters.PrefixLines

All Implemented Interfaces:
  `Closeable, AutoCloseable, Readable, ChainableReader, Parameterizable`

public final class PrefixLines extends BaseParamFilterReader implements ChainableReader
Attaches a prefix to every line. Example:

    <prefixlines prefix="Foo"/>

Or:

    <filterreader classname="org.apache.tools.ant.filters.PrefixLines">
     <param name="prefix" value="Foo"/>
    </filterreader>

- ## Field Summary

  ### Fields inherited from class FilterReader

  `in`

  ### Fields inherited from class Reader

  `lock`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `PrefixLines()`
  Constructor for "dummy" instances.
  `PrefixLines(Reader in)`
  Creates a new filtered reader.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Reader`
  `chain(Reader rdr)`
  Creates a new PrefixLines filter using the passed in Reader for instantiation.
  `int`
  `read()`
  Returns the next character in the filtered stream.
  `void`
  `setPrefix(String prefix)`
  Sets the prefix to add at the start of each input line.

  ### Methods inherited from class BaseParamFilterReader

  `getParameters, setParameters`
  Modifier and Type
  Method
  Description
  `protected final Parameter[]`
  `getParameters()`
  Returns the parameters to be used by this filter.
  `final void`
  `setParameters(Parameter... parameters)`
  Sets the parameters used by this filter, and sets the filter to an uninitialized status.

  ### Methods inherited from class BaseFilterReader

  `getInitialized, getProject, read, readFully, readLine, setInitialized, setProject, skip`
  Modifier and Type
  Method
  Description
  `protected final boolean`
  `getInitialized()`
  Returns the initialized status.
  `protected final Project`
  `getProject()`
  Returns the project this filter is part of.
  `final int`
  `read(char[] cbuf, int off, int len)`
  Reads characters into a portion of an array.
  `protected final String`
  `readFully()`
  Reads to the end of the stream, returning the contents as a String.
  `protected final String`
  `readLine()`
  Reads a line of text ending with '\n' (or until the end of the stream).
  `protected final void`
  `setInitialized(boolean initialized)`
  Sets the initialized status.
  `final void`
  `setProject(Project project)`
  Sets the project to work with.
  `final long`
  `skip(long n)`
  Skips characters.

  ### Methods inherited from class FilterReader

  `close, mark, markSupported, ready, reset`

  ### Methods inherited from class Reader

  `nullReader, of, read, read, readAllAsString, readAllLines, transferTo`

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### PrefixLines

    public PrefixLines()
    Constructor for "dummy" instances.
    See Also:
      - `BaseFilterReader()`

  - ### PrefixLines

    public PrefixLines(Reader in)
    Creates a new filtered reader.
    Parameters:
      `in` - A Reader object providing the underlying stream. Must not be `null`.

- ## Method Details

  - ### read

    public int read() throws IOException
    Returns the next character in the filtered stream. One line is read from the original input, and the prefix added. The resulting line is then used until it ends, at which point the next original line is read, etc.
    Overrides:
      `read` in class `FilterReader`
    Returns:
      the next character in the resulting stream, or -1 if the end of the resulting stream has been reached
    Throws:
      `IOException` - if the underlying stream throws an IOException during reading

  - ### setPrefix

    public void setPrefix(String prefix)
    Sets the prefix to add at the start of each input line.
    Parameters:
      `prefix` - The prefix to add at the start of each input line. May be `null`, in which case no prefix is added.

  - ### chain

    public Reader chain(Reader rdr)
    Creates a new PrefixLines filter using the passed in Reader for instantiation.
    Specified by:
      `chain` in interface `ChainableReader`
    Parameters:
      `rdr` - A Reader object providing the underlying stream. Must not be `null`.
    Returns:
      a new filter based on this configuration, but filtering the specified reader